#include "retis_lcd2x16.h"
#include "ee.h"

void lcd2x16_init(uint8_t lcd_channel, lcd_conf_data_t *init)
{
  EE_lcd_init(); /* Initialize the display.   */
}

void lcd2x16_write(uint8_t lcd_channel, char *buf, uint8_t num)
{
  int i=0;
  for(;i<num;i++)
    EE_lcd_putc(*(buf+i));
}

void lcd2x16_read(uint8_t lcd_channel, char *buf, uint8_t num)
{
}

void lcd2x16_control(uint8_t lcd_channel, uint8_t param, void *value)
{
  switch(param) {
  case SET_CURSOR_POSITION:
	EE_lcd_goto((EE_UINT8)*((uint8_t *)value), (EE_UINT8)(*((uint8_t *)value+1)));
    break;
  case CLEAR_SCREEN:
    EE_lcd_clear();
    break;
  case CURSOR_HOME:
    EE_lcd_home();
    break;
  case CURSOR_LEFT:
    EE_lcd_curs_left();
    break;
  case CURSOR_RIGHT:
    EE_lcd_curs_right();
    break;
  default:
    break;
  }
}

/*
void EE_lcd_line2 (void)		
void EE_lcd_shift (void)	
void EE_lcd_pulse_enable( void )
void EE_lcd_command( EE_UINT8 cmd )   	Send a command to the lcd.  
void EE_lcd_brightness( EE_UINT8 btns_status )    Switch on or off the back illumination  
void EE_lcd_switch( EE_UINT8 lcd_status )	Switch on or off the display  
void EE_lcd_putc( unsigned char data )	Send a data.  
unsigned char EE_lcd_busy( void )	Check if the display is busy

*/
