#include "retis_compiler.h"
#include "touch.h"

#define Touch_read touch_read
#define Touch_init touch_init
#define Touch_conf touch_conf

#define TOUCH_WAIT_POLL_PIN	0
#define TOUCH_RAW_CONV_PIN	1
#define TOUCH_SIG_UNSIG_PIN	2

// Initialization triggers
#define POLLING (0 << TOUCH_WAIT_POLL_PIN)
#define BLOCKING (1 << TOUCH_WAIT_POLL_PIN)
#define CONV_FORMAT (0 << TOUCH_RAW_CONV_PIN)
#define RAW_FORMAT (1 << TOUCH_RAW_CONV_PIN)
#define UNSIGNED_FORMAT (0 << TOUCH_SIG_UNSIG_PIN)
#define SIGNED_FORMAT (1 << TOUCH_SIG_UNSIG_PIN)

#define SET_X_RANGE_TAG			0x00
#define SET_Y_RANGE_TAG			0x01
#define SET_POLL_TAG			0x02
#define SET_WAIT_TAG			0x03
#define SET_RAW_TAG				0x04
#define SET_UNSIGNED_TAG		0x05
#define SET_SIGNED_TAG			0x06
#define SET_CAL_PAR_TAG   		0x07
#define SET_READ_MODE_TAG		0x08

// TOUCH_X_AXIS and TOUCH_Y_AXIS macros already defined in the driver

typedef struct {
	uint16_t x_range;
	uint16_t y_range;
	tune_raw_t tune; 
	uint8_t autostart;
	uint8_t read_mode;
} touch_conf_data_t;

void touch_init(uint8_t channel, touch_conf_data_t *init);
void touch_conf(uint8_t channel, uint8_t tag, void *value);

int8_t touch_read_coord(uint8_t channel, uint8_t coord,	void *value);
