#! /usr/bin/env python

import sys
import os
import time
from subprocess import Popen, PIPE, STDOUT

do_infinite_wait = True

def infinite_wait():
    if not do_infinite_wait:
        return
    while True:
        try:
            time.sleep(60)
        except:
            print "\nGoodbye, cruel world.\n"
            break
    time.sleep(1)

def main(argv=None):
    time_start = time.time()
    if os.name == "posix":
        defaut_eclipse_home = "/path/to/eclipse_home"
        rt_druid = "evidence/dont_know"
        maker =  'command/to/build'
    elif os.name == "nt":
        defaut_eclipse_home = 'C:\\Evidence\\Evidence\\eclipse'
        default_eclipse_home_cygwin = '/cygdrive/c/Evidence/Evidence/eclipse'
        cmd_prologue = 'C:\\cygwin\\bin\\bash -c "/bin/bash --login'
        cmd_prologue += ' -c \\"cd `/bin/cygpath/ -ms \\"$PWD\\"`; '
        cmd_epilogue = '\\""'
        rt_druid = default_eclipse_home_cygwin
        rt_druid += '/evidence/rtd_launcher.bat'
        rt_druid += ' --oil conf.oil --output Release\\""'
        rt_druid = cmd_prologue + rt_druid + cmd_epilogue
        maker = cmd_prologue + 'cd Release; make all; cd ..' + cmd_epilogue
    else:
        sys.exit("OS not supported")
    if not os.getenv("ECLIPSE_HOME"):
        os.putenv("ECLIPSE_HOME", defaut_eclipse_home)
    print ""
    print ""
    print "+-+-+-+-+-+-+-+-+-+-+-  CODE GENERATOR  +-+-+-+-+-+-+-+-+-+-+-+->>>"
    print ""
    try:
        import retis_code_generator
    except:
        print "FAILURE. Unable to import code-generator script."
        infinite_wait()
    if not retis_code_generator.main(argv):
        print "FAILURE. Retis Code Generator failed. Stop build process."
        infinite_wait()
    return
    print ""
    print "^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^"
    print ""
    print ""
    print "+-+-+-+-+-+-+-+-+-+-+-+-  RT-DRUID  +-+-+-+-+-+-+-+-+-+-+-+-+-+->>>"
    print ""
    p = Popen(rt_druid, shell=True,stdout=sys.stdout,stderr=STDOUT)
    # TODO: check the out status of the rt-druid 
    p.wait()
    print ""
    print "^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^"
    print ""
    print ""
    print "+-+-+-+-+-+-+-+-+-+-+-  TOOL-CHAIN  +-+-+-+-+-+-+-+-+-+-+-+-+-+->>>"
    p = Popen(maker, shell=True,stdout=sys.stdout,stderr=STDOUT)
    p.wait()
    print ""
    print "^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^"
    print ""
    elapsed_time = time.time() - time_start
    print "Done. Total time %u:%u." % (elapsed_time / 60, elapsed_time % 60)
    infinite_wait()

# MAIN #

if __name__ == '__main__':
    main()
