from gui import MainWindow
from PyQt4 import QtGui, QtCore 
import sys

def create_element_dict():
	uDict = dict()	
	for i in ['dspic33FJ256MC710']:
		
		bDict = dict()
		for e in ['flex_demoboard', 'flex_motionboard']:
			eDict = dict()
			if e == 'flex_demoboard':
				eDict['led'] = range(8)
				eDict['button'] = range(4)
				eDict['servomotor'] = range(2)
				eDict['touch'] = range(1)
				eDict['lcd2x16'] = range(1)
			elif e == 'flex_motionboard':
				eDict['led'] = range(2)
				eDict['button'] = range(2)
				eDict['servomotor'] = range(2)
				eDict['touch'] = range(1)
			bDict[e] = eDict
			del eDict
		uDict[i] = bDict
		del bDict
	return uDict

def create_hclist():
	_list = []
	_list1 = []
	_list1.append(['host_machine', [['os_name', 'win32']], None])
	_list1.append(['system_tick', [['value', '1'], ['unit', 'ms']], None])
	_list1.append(['system_frequency', [['value', '40'], ['unit', 'MHz']], None])
	_list1.append(['output_dir', [['path', '.']], None])
	_list1.append(['lib_retis_dir', [['path', 'C:\MBD\mbd_retis']], None])
	_list1.append(['lib_retis_inc', [['name', 'retis.h']], None])
	_list.append(['config',None, _list1])
	del _list1
	return _list

def main(argv=None):
	app = QtGui.QApplication(sys.argv)
	uDict = create_element_dict()
	create_hclist()
	win = MainWindow(uDict, create_hclist(), argv)
	win.show()
	sys.exit(app.exec_())

if __name__ == '__main__':
    main()
