from xml.dom import minidom
from xml.dom.minidom import Document
import sys

class xmlTree:
	def __init__(self, filename="retis_mappings.xml", enc="ISO-8859-1"):
		self.doc = Document()
		self.fname = filename
		self.enc = "ISO-8859-1"
		self.tree = dict()
		self.nname = dict()
		self.root = None

	def write_to_file(self):
		fp = open(self.fname, "w")
		self.doc.writexml(fp, "", "	", "\n", self.enc)
		fp.close()

	def print_to_screen(self):
		print self.doc.toprettyxml(indent="  ")

	def create_root(self, name, aList):
		self.root = self.doc.createElement(name) 
		self.doc.appendChild(self.root)
		if aList:
			self.set_attribute(self.root, aList)

	def create_element(self, appnode, name, aList):
		if name in self.nname:
			self.nname[name] += 1
		else:
			self.nname[name] = 0
		node = self.doc.createElement(name) 
		#print 'name', name
		dname = name + '_' + str(self.nname[name])
		if aList:
			self.set_attribute(node, aList)
		self.tree[dname] = node
		self.append_child(appnode, self.tree[dname])
		return dname

	def append_child(self, appnode, node):
		if appnode == 'root':
			if self.root:
				self.root.appendChild(node)
			else:
				print "Root node is not created"
				sys.exit(0)
		else:
			self.tree[appnode].appendChild(node)

	def set_attribute(self, node, aList):
		if aList:
			for e in aList:
				#print 'set_att ', e[0], e[1]
				node.setAttribute(e[0], e[1])

	def create_subtree(self, appnode, nlist):
		#print nlist
		for e in nlist:
			#print 'e', e
			act_name = self.create_element(appnode, e[0] , e[1])
			if e[2]:
#				print 'e', e
				self.create_subtree(act_name, e[2])
	
	def create_entry(self, name, aList, bList):
		_list = [name]
		_list.append(aList)
		_list.append(bList)
		return _list

	def create_n_entry(self, nameV, aListV, bListV):
		_list = []
		if nameV:
#			print len(nameV)
			for e in range(len(nameV)):
				_l = []
				_l .append(nameV[e])
				if aListV[e]:
					_l.append([aListV[e]])
				else:
					_l.append(None)
				if bListV[e]:
					_l.append([bListV[e]])
				else:
					_l.append(None)
				_list.append(_l)
		return _list

#t = xmlTree()
#alist = []
#ylist = []
#alistV = []
#blistV = []
#nV = []
#for i in range(5):
#	nV.append('azz' + '_' + str(i))
#	alist = ['func' + '_' + str(i), 'pippo']
#	ylist = ['puc' + '_' + str(i), 'pappo']
#	alistV.append(alist)
#	blistV.append(None)

#rlist = t.create_n_entry(nV, alistV, blistV)
#r1list = []
#r1list.append(t.create_entry('appio', None, rlist))	

##rlist.append(c.create_entry('name', _list, None))

#t.create_subtree('root', r1list)
#t.print_to_screen()
##	def create_n_element(self, appnode, nList):
##		node = []	
##		if nList:
##			for e in nList:	
##				aList = []
##				for h in range(1, len(e)):
##					aList.append(e[h])
##				node.append(create_element(self.doc, appnode, e[0], aList))
##		return node



##t = xmlTree()
##_list = []

##elist = []

##alist = []

##ylist = []

##alist.append(['func', 'pippo'])
##ylist. append(['puc', alist, None])
##elist.append(['led', alist, ylist])
##del alist

##alist = []

##alist.append(['func', 'pippa'])
##elist.append(['led', alist, None])

##del alist

##alist = []

##alist.append(['func', 'pippe'])
##elist.append(['button', alist, None])

##del alist
##alist = []
##alist.append(['b', 'ppu'])

##_list.append(['b',alist, elist])

##print _list
##t.create_subtree('root', _list)
##t.print_to_screen()
##print t.tree
